Bug 985358 - Review Request: rubygem-hashie - A small collection of tools that make hashes more powerful
Review Request: rubygem-hashie - A small collection of tools that make hashes...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ricky Elrod
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-07-17 06:44 EDT by Achilleas Pipinellis
Modified: 2013-08-05 20:16 EDT (History)
3 users (show)

See Also:
Fixed In Version: rubygem-hashie-2.0.5-1.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-08-05 20:16:36 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
relrod: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Achilleas Pipinellis 2013-07-17 06:44:17 EDT
Spec URL: http://axilleas.fedorapeople.org/pkgs/rubygem-hashie/rubygem-hashie.spec
SRPM URL: http://axilleas.fedorapeople.org/pkgs/rubygem-hashie/rubygem-hashie-2.0.5-1.fc20.src.rpm

Description: 
Hashie is a small collection of tools that make hashes more powerful.
Currently includes Mash (Mocking Hash) and Dash (Discrete Hash).

Fedora Account System Username: axilleas

Koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=5618669
Comment 1 Ricky Elrod 2013-07-20 11:10:59 EDT
Here's a first go at this. Major issues are at the top, there's a few more things (like not using all the fancy rubygem-devel macros) inline, that you might be able to fix too.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- gems should require rubygems package
  Note: Requires: rubygems missing in rubygem-hashie-doc
  See: http://fedoraproject.org/wiki/Packaging:Ruby#RubyGems

- If you're building for F18- you need to conditionalize ruby(abi):

%if 0%{?fedora} >= 19
Requires: ruby(release)
%else
Requires: ruby(abi) >= 1.9.1
%endif

- Fully version the -doc subpackage:
  Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rubygem-
  hashie-doc


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[!]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[!]: Fully versioned dependency in subpackages, if present.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rubygem-
     hashie-doc
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.

Ruby:
[-]: Platform dependent files must all go under %{gem_extdir}, platform
     independent under %{gem_dir}.
[x]: Gem package must not define a non-gem subpackage
[x]: Gem package is named rubygem-%{gem_name}
[x]: Package contains BuildRequires: rubygems-devel.
[x]: Gem package must define %{gem_name} macro.
[x]: Pure Ruby package must be built as noarch

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

Ruby:
[!]: Specfile should use macros from rubygem-devel package.
     Note: The specfile doesn't use these macros: %doc %{gem_docdir}, %exclude
     %{gem_cache}, %{gem_spec}, %{gem_libdir}
[x]: Test suite of the library should be run.
[x]: Gem package should exclude cached Gem.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rubygem-hashie-2.0.5-1.fc20.noarch.rpm
          rubygem-hashie-doc-2.0.5-1.fc20.noarch.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint rubygem-hashie rubygem-hashie-doc
2 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'



Requires
--------
rubygem-hashie (rpmlib, GLIBC filtered):
    ruby(release)
    ruby(rubygems)

rubygem-hashie-doc (rpmlib, GLIBC filtered):
    rubygem-hashie



Provides
--------
rubygem-hashie:
    rubygem(hashie)
    rubygem-hashie

rubygem-hashie-doc:
    rubygem-hashie-doc



Source checksums
----------------
https://rubygems.org/gems/hashie-2.0.5.gem :
  CHECKSUM(SHA256) this package     : 77c7ca7616cc3b1f115e749c24b85fb0926d50e94e19d8c75fcda2675152c63f
  CHECKSUM(SHA256) upstream package : 77c7ca7616cc3b1f115e749c24b85fb0926d50e94e19d8c75fcda2675152c63f


Generated by fedora-review 0.4.1 (b2e211f) last change: 2013-04-29
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 985358
Comment 2 Achilleas Pipinellis 2013-07-22 04:40:59 EDT
(In reply to Ricky Elrod from comment #1)
> Here's a first go at this. Major issues are at the top, there's a few more
> things (like not using all the fancy rubygem-devel macros) inline, that you
> might be able to fix too.
> 

Hi Ricky! Thanks for taking the time to review this. This is one of my first packages so I might have a few questions. Comments inline.


> - gems should require rubygems package
>   Note: Requires: rubygems missing in rubygem-hashie-doc
>   See: http://fedoraproject.org/wiki/Packaging:Ruby#RubyGems
> 

As far as I know, doc subpackages depend on the real package which in turns Requires: ruby(rubygems). So adding rubygems to -doc isn't really needed. Am I wrong?

> - If you're building for F18- you need to conditionalize ruby(abi):
> 
> %if 0%{?fedora} >= 19
> Requires: ruby(release)
> %else
> Requires: ruby(abi) >= 1.9.1
> %endif

I am not building for F18 at this point, but if you think it's better to support F18 as well, I guess I could make this change.


> - Fully version the -doc subpackage:
>   Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rubygem-
>   hashie-doc

As per the guidelines, this would be the case of an arch dependent package [0]. Since this is noarch I think the %{?_isa} doesn't apply. Correct me if I am wrong.

> ===== MUST items =====
> 
> Generic:
>
> [!]: Package requires other packages for directories it uses.

I don't understand how that applies to the spec. Could you please explain it?

> [!]: Requires correct, justified where necessary.

What else am I missing from Requires? hashie doesn't have any other gem dependencies so the only Requires should be ruby(release) and ruby(rubygems), right?

> ===== SHOULD items =====
> 
> Ruby:
> [!]: Specfile should use macros from rubygem-devel package.
>      Note: The specfile doesn't use these macros: %doc %{gem_docdir},
> %exclude %{gem_cache}, %{gem_spec}, %{gem_libdir}

I don't understand why fedora-review marked these as not being used. I have all of them in my specfile...


[0] https://fedoraproject.org/wiki/Packaging:Guidelines#Requiring_Base_Package
Comment 3 Ricky Elrod 2013-07-22 05:08:48 EDT
>  As far as I know, doc subpackages depend on the real package which in turns Requires: ruby(rubygems). So adding rubygems to -doc isn't really needed. Am I wrong?

That's a good point, I'm not sure why fedora-review didn't pick that up. I think it might be "ruby(rubygems)" vs just "rubygems", but I think either is fine.

> I am not building for F18 at this point, but if you think it's better to support F18 as well, I guess I could make this change.

If you're only planning on building for F19+, then it's fine as-is. If you decide to build for F18-, you'll need to change it.

> As per the guidelines, this would be the case of an arch dependent package [0]. Since this is noarch I think the %{?_isa} doesn't apply. Correct me if I am wrong.

That is correct and fedora-review bit again ;). https://fedoraproject.org/wiki/Packaging:Guidelines#Requiring_Base_Package says "When a subpackage requires the base package, it must do so using a fully versioned arch-specific (for non-noarch packages) dependency: "

I'll see if I can file a bug (or patch) on fedora-review to not give that error if the base package is noarch.

> I don't understand how that applies to the spec. Could you please explain it?

This error and the one below it seem to also be a result of fedora-review not seeing the "Requires: ruby(rubygems)". Sorry for not catching that.

With that said, if you're only going to build for F19+, this looks fine and is APPROVED.
Comment 4 Achilleas Pipinellis 2013-07-22 06:12:27 EDT
New Package SCM Request
=======================
Package Name: rubygem-hashie
Short Description: A small collection of tools that make hashes more powerful
Owners: axilleas
Branches: f19
InitialCC:
Comment 5 Gwyn Ciesla 2013-07-22 08:25:58 EDT
Git done (by process-git-requests).
Comment 6 Fedora Update System 2013-07-22 16:47:43 EDT
rubygem-hashie-2.0.5-1.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/rubygem-hashie-2.0.5-1.fc19
Comment 7 Fedora Update System 2013-07-23 23:35:35 EDT
rubygem-hashie-2.0.5-1.fc19 has been pushed to the Fedora 19 testing repository.
Comment 8 Fedora Update System 2013-08-05 20:16:36 EDT
rubygem-hashie-2.0.5-1.fc19 has been pushed to the Fedora 19 stable repository.

Note You need to log in before you can comment on or make changes to this bug.